dot/ipython_config.py: Let's just have one of these for everywhere.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
119echo " all done."
120
121###--------------------------------------------------------------------------
122### Install global configuration.
123
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
132## Symlink the various dotfiles into place
133dotfiles="
134 bash_profile bash_logout bashrc inputrc bash_completion
135 emacs emacs-calc vm gnus.el ercrc.el
136 vimrc mg zile lesskey
137 parallel-config:.parallel/config
138 ipython_config.py:.ipython/profile_default/ipython_config.py
139 ditz-config
140 mailrc signature muttrc
141 cgrc tigrc
142 gdbinit
143 guile
144 rcrc
145 toprc
146 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
147 pulse-daemon.conf:.pulse/daemon.conf
148 aspell.conf
149 tclshrc:.tclshrc tclshrc:.wishrc
150 lisp-init.lisp:.cmucl-init.lisp
151 lisp-init.lisp:.sbclrc
152 lisp-init.lisp:.clisprc.lisp
153 lisp-init.lisp:.eclrc
154 swank.lisp
155 mdw-build.conf:.config/mdw-build.conf
156 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
157 dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
158[ "$xstuff" ] && dotfiles="$dotfiles
159 xinitrc xsession xmodmap vncrc vncsession
160 fonts.conf
161 stalonetrayrc
162 putty-defaults:.putty/sessions/Default%20Settings
163 mdw.session:.config/gnome-session/sessions/mdw.session
164 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
165 e-keybindings.cfg:.enlightenment/keybindings.cfg
166 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
167 e16-bindings:.e16/bindings.cfg"
168echo "Installing dotfiles..."
169for d in $dotfiles; do
170 target=.$d
171 case $d in
172 *:*) target=${d#*:} d=${d%%:*};;
173 esac
174 ft=$HOME$sub/$target
175 dir=${ft%/*}
176 mkdir -p $dir
177 ln -s $here/dot/$d $ft.new
178 mv $ft.new $ft
179 echo " $target"
180done
181echo " all done."
182
183## CPP-hack files which need it.
184cppfiles=""
185[ "$xstuff" ] && cppfiles="$cppfiles
186 Xdefaults"
187echo "Hacking files with C preprocessor..."
188for c in $cppfiles; do
189 target=.$c
190 case $c in
191 *:*) target=${c#*:} c=${c%%:*};;
192 esac
193 ft=$HOME$sub/$target
194 dir=${ft%/*}
195 mkdir -p $dir
196 cpp -P dot/$c -o $ft.new
197 mv $ft.new $ft
198 echo " $target"
199done
200echo " all done."
201
202## Substitute things which need substituting.
203dotfilessubst="
204 gitconfig
205 mykermrc
206 pulse-default.pa.in:.pulse/default.pa"
207echo "Installing dotfiles with substitutions..."
208for d in $dotfilessubst; do
209 case $d in
210 *:*) target=${d#*:} d=${d%%:*};;
211 *) target=.$d d=$d.in;;
212 esac
213 ft=$HOME$sub/$target
214 dir=${ft%/*}
215 mkdir -p $dir
216 sed "
2171i\\
218### generated by $here/setup; do not edit!\\
219
220/@home@/ s\a\a$HOME\ag
221/@profile@/ s\a\a$here\ag
222/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
223" dot/$d >$ft.new
224 mv $ft.new $ft
225 echo " $target"
226done
227echo " all done."
228
229## Symlink backgrounds.
230backgrounds="
231 bsg-supper.jpg
232 harley-quinn.jpg
233 hypatia.jpg
234 jue-peek.jpg
235 lilith.jpg
236 lovelace.jpg
237 medusa.jpg
238 noodly.jpg
239 rayne.jpg
240"
241if [ "$xstuff" ]; then
242 echo "Installing backgrounds..."
243 for b in $backgrounds; do
244 for e in enlightenment e16; do
245 dir=$HOME$sub/.$e/backgrounds
246 t=$dir/$b
247 mkdir -p $dir
248 ln -s $here/bg/$b $t.new
249 mv $t.new $t
250 done
251 echo " $b"
252 done
253 echo " all done."
254fi
255
256###--------------------------------------------------------------------------
257### Install useful scripts included in this package.
258
259scripts="
260 mdw-editor
261 mdw-pager
262 mdw-conf
263 mdw-build mdw-sbuild mdw-sbuild-server
264 update-buildable-branch
265 emacsclient-hack
266 movemail-hack
267 sendmail-hack
268 aspell-hack
269 emerge-hack
270 lesspipe.sh
271 run-with-shell-env
272 start-ssh-agent
273 start-ssh-pageant
274 svnwrap
275 guest-console
276 hyperspec"
277[ "$xstuff" ] && scripts="$scripts
278 xinitcmd
279 un-backslashify-selection
280 lock-screen
281 xpra-start-xdummy
282 xshutdown"
283echo "Installing scripts..."
284mkdir -p $HOME$sub/bin
285for s in $scripts; do
286 ft=$HOME$sub/bin/$s
287 ln -s $here/bin/$s $ft.new
288 mv $ft.new $ft
289 echo " $s"
290done
291echo " all done."
292
293hacks="
294 ssh:ssh"
295echo "Installing hacks..."
296for h in $hacks; do
297 d=${h%%:*} h=${h#*:}
298 ft=$HOME$sub/bin/hacks/$d
299 mkdir -p $ft
300 ln -s $here/hacks/$h $ft/$h.new
301 mv $ft/$h.new $ft/$h
302 echo " $d:$h"
303done
304echo " all done."
305
306###--------------------------------------------------------------------------
307### Set up the Emacs config.
308
309$echon "Finding a suitable emacs:$echoc"
310emacs=no
311for i in emacs23 emacs24 emacs22 emacs21 emacs; do
312 if type -p >/dev/null $i; then
313 emacs=$i
314 break
315 fi
316done
317if [ $emacs = no ]; then
318 echo " failed."
319 emacs=:
320else
321 echo " $emacs."
322fi
323
324echo "Installing Emacs packages..."
325emacspkg="
326 make-regexp
327 ew-hols
328 mdw-gnus-patch
329 git git-blame vc-git stgit
330 mdw-multiple-cursors
331 quilt"
332for elib in $emacspkg; do
333 $echon " $elib:$echoc"
334 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
335 (progn
336 (setq load-path (nconc load-path (list "~/lib/emacs")))
337 (kill-emacs (condition-case nil
338 (progn (load-library "'"$elib"'") 0)
339 (error 1))))'; then
340 echo " already installed."
341 else
342 if [ -f el/$elib.el ]; then
343 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
344 else
345 $echon " downloading$echoc"
346 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
347 fi
348 $echon " compiling$echoc"
349 (cd $HOME$sub/lib/emacs;
350 $emacs >/dev/null 2>&1 --no-site-file --batch \
351 --eval '(byte-compile-file "'"$elib.el"'")')
352 echo " done."
353 fi
354done
355echo " all done."
356
357$echon "Setting up Emacs configuration:$echoc"
358$echon " linking$echoc"
359for f in dot-emacs.el Makefile; do
360 set -- $(echo $link | tr : ' ')
361 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
362 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
363done
364$echon " compiling$echoc"
365{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
366echo " done."
367
368###----- That's all, folks --------------------------------------------------